var index = true;  // fr Prfung of mit index.html gestartet wurde

if(navigator.appName != "Microsoft Internet Explorer")
  {
  location.href = "nurIE.html"; // wenn nicht mit IE gestartet wurde
  }
else
  {
  var fso = new ActiveXObject("Scripting.FileSystemObject");

  var pfad = location.pathname.replace(/index.html/, "");
  pfad = pfad.replace(/\//, "");
  pfad = pfad.replace(/%20/g, " ");

  var datei = fso.OpenTextFile(pfad + "option.txt");
  var optionen = datei.ReadAll().split("\n");
  datei.Close();

  for(i = 0; i < optionen.length; i++) optionen[i] = parseInt(optionen[i]);
  }

function printList(sprache)
 {
  var Buchstabe = "";

  var daten = getDatei("eng_deu.txt");

  if(sprache == 2)
    {
    for(i = 0; i < daten.length - 1; i++)
      {
      daten[i] = daten[i].split("|");
      daten[i] = daten[i][1] + "|" + daten[i][0];
      }
    }

  for(i = 0; i < daten.length - 1; i++)
    {
    daten[i] += "|" + i;
    }

  if(optionen[0] == 1) daten = quicksort(daten, 0, daten.length - 2);
  else daten = bubblsort(daten);

  var ausgabe = '<table cellpadding="3" cellspacing="0" style="font-family:Arial; font-size:10pt;">';
  for(i = 0; i < daten.length - 1; i++)
    {
    var aktuellerBuchstabe = daten[i].charAt(0);
    aktuellerBuchstabe = aktuellerBuchstabe.toUpperCase();

    if(aktuellerBuchstabe > Buchstabe)
      {
      Buchstabe = aktuellerBuchstabe;
      ausgabe += "<tr><td colspan=3><br><br><h2>" + Buchstabe + "</h2></td></tr>";
      }

    daten[i] = daten[i].split("|");
    if((i/2) == parseInt(i/2)) ausgabe += '<tr><td>' + (i + 1) + '.</td><td>' + daten[i][0] + '</td><td>' + daten[i][1] + '</td></tr>';
      else  ausgabe += '<tr style="background-color:#eeeeee"><td>' + (i + 1) + '.</td><td>' + daten[i][0] + '</td><td>' + daten[i][1] + '</td></tr>';
    }
  ausgabe += "</table>";

  return ausgabe;
  }

function getList(sprache)
  {
  var Buchstabe = "";

  var daten = getDatei("eng_deu.txt");

  if(sprache == 2)
    {
    for(i = 0; i < daten.length - 1; i++)
      {
      daten[i] = daten[i].split("|");
      daten[i] = daten[i][1] + "|" + daten[i][0];
      }
    }

  for(i = 0; i < daten.length - 1; i++)
    {
    daten[i] += "|" + i;
    }

  if(optionen[0] == 1) daten = quicksort(daten, 0, daten.length - 2);
  else daten = bubblsort(daten);

  var ausgabe = "<br><br>";
  var Alphabet = new Array("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "", "", "");
  for(i = 0; i < Alphabet.length; i++)
    {
    ausgabe += "<a href=#" + Alphabet[i] + ">" + Alphabet[i] + "</a> ";
    }
  ausgabe += "<br>";

  for(i = 0; i < daten.length - 1; i++)
    {
    var aktuellerBuchstabe = daten[i].charAt(0);
    aktuellerBuchstabe = aktuellerBuchstabe.toUpperCase();

    if(aktuellerBuchstabe > Buchstabe)
      {
      Buchstabe = aktuellerBuchstabe;
      ausgabe += "<br><h3><a name=" + Buchstabe + ">" + Buchstabe + "</a></h3>&nbsp;&nbsp;&nbsp;<i><a href=#top>zurck</a></i><br><br>";
      }

    daten[i] = daten[i].split("|");
    ausgabe += (i + 1) + '. <a href="javascript:parent.editWord(' + daten[i][2] + ');">' + daten[i][0] + ' - ' + daten[i][1] + '</a><br>';
    }
  return ausgabe;
  }

function getDatei(name)
  {
  var datei = fso.OpenTextFile(pfad + name);
  var inhalt = datei.ReadAll().split("\r\n");
  datei.Close();
  return inhalt;
  }

function getDiagramm(beschreibung, width, text)
  {
  var diagramm = '';
  diagramm += '<table cellspacing=10 border=0>';
  diagramm += '<tr>';
  diagramm += '<td width=150 align=right>' + beschreibung + '</td>';
  diagramm += '<td width=' + width + ' align=left bgcolor=#ffffff><font color=#00007a>' + text + '</font></td>';
  diagramm += '</tr>';
  diagramm += '</table>';
  return diagramm;
  }

function newWiderh(anzahl)
  {
  if(isNaN(anzahl) || anzahl < 1)
    {
    alert("Sie haben keine gltige Zahl eingegeben.");
    return;
    }
  optionen[7] = anzahl;
  writeOptions();
  alert("Der Wert " + anzahl + " wurde eingestellt.");
  }

function newSta()
  {
  if(confirm("Wollen Sie die Statistik wirklich lschen?"))
    {
    for(i = 1; i < 6; i++) optionen[i] = 0;
    writeOptions();
    alert("Die Statistik wurde gelscht.");
    }
  }

function newUeb()
  {
  if(confirm("Wollen Sie die bung wirklich lschen?"))
    {
    datei = fso.OpenTextFile(pfad + "ueb.txt", 2, true);
    datei.WriteLine("0");
    datei.Close();
    optionen[6] = 0;
    writeOptions();
    alert("Die bung wurde neugestartet.");
    }
  }

function newLis()
  {
  if(confirm("Sind Sie sicher, da Sie alle Vokabeln lschen wollen?"))
    {
    while(true)
      {
      var dateiname = prompt("Geben Sie bitte einen Dateinamen an. Die aktuelle Vokabelliste wird dorthin kopiert.", "oldvokli.txt");
      if(dateiname != null)
        {
        if(fso.FileExists(pfad + dateiname))
          {
          if(confirm("Die Datei " + pfad + dateiname + " existiert bereits. Wollen Sie diese ersetzen?"))
            {
            break;
            }
          continue;
          }
        if(confirm("Soll die Vokabelliste wird in die Datei " + pfad + dateiname + " kopiert werden?")) break;
        return;
        }
      return;
      }
    fso.CopyFile(pfad + "eng_deu.txt", pfad + dateiname, true);
    var datei = fso.OpenTextFile(pfad + "eng_deu.txt", 2, true);
    datei.Write("leer");
    datei.close();
    datei = fso.OpenTextFile(pfad + "ueb.txt", 2, true);
    datei.WriteLine("0");
    datei.Close();
    optionen[6] = 0;
    writeOptions();
    alert("Die Vokabelliste wurde in die Datei " + pfad + dateiname + " kopiert.");
    }
  }


function writeOptions()
  {
  datei = fso.OpenTextFile(pfad + "option.txt", 2, true);
  for(i = 0; i < optionen.length - 1; i++) datei.WriteLine(optionen[i]);
  datei.Close();
  }

function getUebListLength()
  {
  var uebList = getDatei("ueb.txt");
  return parseInt(uebList[0]);
  }

function getWord()
  {
  var WordList = getDatei("eng_deu.txt");
  var uebList = getDatei("ueb.txt");

  if(WordList.length < 2) return false; // falls Liste leer

  if(parseInt(uebList[0]) < WordList.length - 1)
    {
    var position = uebList.length - 1;
    for(i = parseInt(uebList[0]); i < WordList.length - 1; i++) uebList[position++] = i + "|1";
    uebList[0] = WordList.length - 1;
    datei = fso.OpenTextFile(pfad + "ueb.txt", 2, true);
    for(i = 0; i < uebList.length; i++) datei.WriteLine(uebList[i]);
    datei.Close();
    }
  else if(uebList.length < 3)
    {
    if(!confirm("Die bung ist beendent. Soll sie neugestartet werden?")) return false; // Wenn kein Neustart erfolgen soll
    optionen[6] = 0;
    writeOptions();
    for(i = 0; i < WordList.length - 1; i++) uebList[i + 1] = i + "|1";
    uebList[0] = WordList.length - 1;
    datei = fso.OpenTextFile(pfad + "ueb.txt", 2, true);
    for(i = 0; i < uebList.length; i++) datei.WriteLine(uebList[i]);
    datei.Close();
    }

  var uebList = getDatei("ueb.txt");
  var pos_in_uebList = parseInt(Math.random() * (uebList.length - 2)) + 1;
  var daten_in_uebList = uebList[pos_in_uebList].split("|");
  var pos_in_WordList = parseInt(daten_in_uebList[0]);
  var anzahl_der_wiederholungen = parseInt(daten_in_uebList[1]);
  var Word = WordList[pos_in_WordList].split("|");
  Word[2] = pos_in_uebList;
  Word[3] = anzahl_der_wiederholungen;
  return(Word);
  }

function delWordformUebList(position)
  {
  var uebList = getDatei("ueb.txt");
  datei = fso.OpenTextFile(pfad + "ueb.txt", 2, true);
  for(i = 0; i < uebList.length - 1; i++) if(i != position) datei.WriteLine(uebList[i]);
  datei.Close();
  return true;
  }

function updateWordformUebList(Word)
  {
  var uebList = getDatei("ueb.txt");
  datei = fso.OpenTextFile(pfad + "ueb.txt", 2, true);
  for(i = 0; i < uebList.length - 1; i++)
    {
    if(i == Word[2]) datei.WriteLine(parseInt(uebList[Word[2]]) + "|" + Word[3]);
      else datei.WriteLine(uebList[i]);
    }
  datei.Close();
  return true;
  }

function creatWord(word)
  {
  var inhalt = getDatei("eng_deu.txt");

  var suchwort = word.split("|");
  var position = new Array();
  var zaehler = 0;
  for(i = 0; i < inhalt.length - 1; i++)
    {
    if(inhalt[i].indexOf(suchwort[0]) != -1 || inhalt[i].indexOf(suchwort[1]) != -1)
      {
      position[zaehler] = i;
      zaehler++;
      }
    }

  if(zaehler != 0)
    {
    var text = "Eine bereinstimmung wurde schon gefunden in:\n\n";
    for(i = 0; i < zaehler; i++)
      {
      var wort = inhalt[position[i]].split("|");
      text += wort[0] + " - " + wort[1] + "\n";
      }
    text += "\nWollen Sie den Eintrag trotzdem erstellen?";

    if(!confirm(text)) return false;
    }

  datei = fso.OpenTextFile(pfad + "eng_deu.txt", 2, true);
  for(i = 0; i < inhalt.length - 1; i++) datei.WriteLine(inhalt[i]);
  datei.WriteLine(word);
  datei.Close();
  return true;
  }

function editWord(nummer)
  {
  var inhalt = getDatei("eng_deu.txt");
  var wort = prompt("Wort ndern:\t\tenglisch|deutsch", inhalt[nummer]);

  if(wort != null && wort.indexOf("|") != -1 && wort.indexOf("|") > 0 && wort.indexOf("|") < wort.length - 1)
    {
    inhalt[nummer] = wort;
    datei = fso.OpenTextFile(pfad + "eng_deu.txt", 2, true);
    for(i = 0; i < inhalt.length - 1; i++) datei.WriteLine(inhalt[i]);
    datei.Close();
    alert("nderung gespeichert.");
    }
  }

function quicksort(sort, l, r)
  {
  var i, j, Temp;
  if(r > l)
    {
    i = l - 1;
    j = r;
    do
      {
      while(sort[++i].toLowerCase() < sort[r].toLowerCase());
      while(sort[--j].toLowerCase() > sort[r].toLowerCase());
      Temp = sort[i];
      sort[i]= sort[j];
      sort[j]= Temp;
      } while(j > i);
    sort[j]= sort[i]; 
    sort[i]= sort[r]; 
    sort[r]= Temp;
    quicksort(sort, l, i - 1); 
    quicksort(sort, i + 1, r);
    }
  return sort;
  }

function bubblsort(daten)
  {
  var Rest;
  var Akt = 0;
  do 
    { 
    Rest = Akt; 
    do 
      {
      Rest++;
      if(daten[Rest].toLowerCase() < daten[Akt].toLowerCase())
        {
        var swap   = daten[Rest];
        daten[Rest] = daten[Akt];
        daten[Akt] = swap;
        }
      } while(Rest < daten.length - 2); // normal: length - 1
      Akt++;
    } while(Akt < daten.length - 2); // normal: length - 1
  return daten;
  }